<template>
  <div id="db-todo-list" class="flex flex-col w-1/2">
    <div class="w-full flex flex-row justify-between">
      <vs-dropdown vs-custom-content vs-trigger-click class="cursor-pointer">
        <a class="flex items-center h3 db-font" href="#">
          <feather-icon
            icon="CheckCircleIcon"
            :svgClasses="['w-10', 'h-10 mr-4']"
          />
          Nhiệm vụ
          <i class="material-icons"> expand_more </i>
        </a>
        <vs-dropdown-menu>
          <BaseSwitchTile
            class="p-2"
            title="Show all"
            :value="showAllData"
            leadingIcon="EyeIcon"
            color="success"
            @change="onChangeShowAll"
          />
        </vs-dropdown-menu>
      </vs-dropdown>
      <feather-icon
        class="cursor-pointer"
        icon="FilterIcon"
        svgClasses="text-white"
        @click="function() {}"
      />
    </div>
    <div class="w-full mt-6">
      <VuePerfectScrollbar
        ref="mainSidebarPs"
        class="scroll-area--nofications-dropdown py-4"
        :settings="settings"
        :key="$vs.rtl"
      >
        <ul v-if="taskList.length != 0">
          <li
            v-for="task in taskList"
            :key="task.index"
            @click="$emit('edit', task)"
            class="flex justify-between px-4 m-0 notification cursor-pointer"
          >
            <div class="flex items-start w-full">
              <div class="mx-2 w-full">
                <vx-card class="grid-view-item mb-4 overflow-hidden w-full">
                  <div class="flex flex-row justify-between">
                    <div class="flex">
                      <div>
                        <h6
                          class="truncate"
                          style="width: 200px; overflow: auto;"
                        >
                          {{ task.name }}
                        </h6>
                        <div class="flex items-center">
                          <div class="mt-3 flex items-center mr-5">
                            <feather-icon
                              icon="ListIcon"
                              svgClasses="h-5 w-5 mr-2 bg-light rounded-full p-1"
                            ></feather-icon>
                            <small class="font-bold">{{
                              completedSubTaskInfo(task)
                            }}</small>
                          </div>
                          <div class="todo-tags mt-3">
                            <vs-chip
                              :color="labelColor(task.project)"
                              transparent
                            >
                              <feather-icon
                                icon="BriefcaseIcon"
                                svgClasses="w-3 h-3"
                              />
                              <div
                                class="h-2 w-2 rounded-full mr-1"
                                :style="
                                  'background-color:' + labelColor(task.project)
                                "
                              ></div>
                              <span>{{ task.project.name | capitalize }}</span>
                            </vs-chip>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                  <div
                    class="absolute top-0 right-0 flex sm:justify-end pr-2 pt-3"
                  >
                    <div
                      v-if="!task.isStarred && task.dueDate"
                      class="flex items-center"
                    >
                      <small class="font-bold text-warning mr-2">{{
                        dueDateFriendly(task)
                      }}</small>
                      <feather-icon
                        icon="CalendarIcon"
                        :svgClasses="[
                          'text-white font-bold stroke-current rounded-full bg-warning p-1',
                          'w-6',
                          'h-6 mr-4'
                        ]"
                      />
                    </div>
                    <feather-icon
                      v-if="task.isStarred"
                      icon="StarIcon"
                      size="sm"
                      :svgClasses="[
                        'text-white font-bold stroke-current rounded-full bg-warning p-1',
                        'w-6',
                        'h-6 mr-4'
                      ]"
                    />
                  </div>
                </vx-card>
              </div>
            </div>
          </li>
        </ul>
        <div v-else class="text-center py-10">
          <img
            src="@/assets/images/empty/empty.svg"
            alt="graphic-404"
            class="mx-auto mb-4 w-1/3"
          />
          <div class="text-white">
            Hãy tạo nhiệm vụ đầu tiên của bạn.
          </div>
        </div>
      </VuePerfectScrollbar>
    </div>
  </div>
</template>

<script>
import VuePerfectScrollbar from "vue-perfect-scrollbar";
import BaseSwitchTile from "../../components/form-elements/BaseSwitchTile";
import { todoLabelColor, todoPriorityColor } from "../../core/utils/color";
import { getFriendlyDate } from "../../core/utils/date";

export default {
  components: {
    VuePerfectScrollbar,
    BaseSwitchTile
  },
  props: {
    tasks: { type: Array, default: () => [] }
  },
  data() {
    return {
      taskList: this.tasks,
      showAllData: true,
      filter: "all",
      settings: {
        maxScrollbarLength: 60,
        wheelSpeed: 0.6
      }
    };
  },
  computed: {
    labelColor() {
      return label => {
        return todoLabelColor(label.color).color;
      };
    },
    priorityColor() {
      return task => {
        const code = todoPriorityColor(task.priority).color;
        return todoLabelColor(code).color;
      };
    },
    dueDateFriendly() {
      return task => {
        return getFriendlyDate(task.dueDate);
      };
    },
    completedSubTaskInfo() {
      return task => {
        const completed = task.checkList.filter(item => item.isDone == true);
        return `${completed.length}/${task.checkList.length}`;
      };
    }
  },
  methods: {
    onChangeShowAll(value) {
      this.showAllData = value;
    },
    elapsedTime(startTime) {
      let x = new Date(startTime);
      let now = new Date();
      var timeDiff = now - x;
      timeDiff /= 1000;

      var seconds = Math.round(timeDiff);
      timeDiff = Math.floor(timeDiff / 60);

      var minutes = Math.round(timeDiff % 60);
      timeDiff = Math.floor(timeDiff / 60);

      var hours = Math.round(timeDiff % 24);
      timeDiff = Math.floor(timeDiff / 24);

      var days = Math.round(timeDiff % 365);
      timeDiff = Math.floor(timeDiff / 365);

      var years = timeDiff;

      if (years > 0) {
        return years + (years > 1 ? " Năm " : " Năm ") + "trước";
      } else if (days > 0) {
        return days + (days > 1 ? " Ngày " : " Ngày ") + "trước";
      } else if (hours > 0) {
        return hours + (hours > 1 ? " Giờ " : " Giờ ") + "trước";
      } else if (minutes > 0) {
        return minutes + (minutes > 1 ? " Phút " : " Phút ") + "trước";
      } else if (seconds > 0) {
        return seconds + (seconds > 1 ? " giây trước" : "ngay bây giờ");
      }

      return "Ngay Bây Giờ";
    },
    // Method for creating dummy notification time
    randomDate({ hr, min, sec }) {
      let date = new Date();

      if (hr) date.setHours(date.getHours() - hr);
      if (min) date.setMinutes(date.getMinutes() - min);
      if (sec) date.setSeconds(date.getSeconds() - sec);

      return date;
    }
  }
};
</script>

<style lang="scss">
@import "../../assets/scss/vuexy/_variables.scss";
#db-todo-list {
  margin-top: 5%;

  .db-font {
    color: white !important;
  }

  .grid-view-item {
    width: 100%;
    .grid-view-img {
      max-width: 100%;
      max-height: fit-content;
      width: auto;
      transition: 0.35s;
    }

    &:hover {
      transform: translateY(-5px);
      box-shadow: 0px 4px 25px 0px rgba(0, 0, 0, 0.25);

      .grid-view-img {
      }
    }
  }

  .scroll-area--nofications-dropdown,
  .scroll-area--cart-items-dropdowm {
    max-height: 40rem;
  }

  .ntf-image {
    margin-left: 0.04rem;
    min-width: 50px;
    overflow: hidden;
    transition: all 0.2s ease-in-out;

    &:hover {
      transform: scale(1.01);
    }
  }
  .bg-light {
    background-color: rgba(212, 212, 212, 0.568);
  }
  .todo-tags {
    .con-vs-chip {
      margin-right: 2px !important;
    }
  }
}
</style>
